/* -----------------------------------------------------------------------------
*
* Header-file for bxtinfo.c
*
* bxtptinfo: dump partition/geometry info
* 
* Note: the relevant code was taken from sfdisk, which is part of the
*       util-linux package (Copyright (C) 1995  Andries E. Brouwer (aeb@cwi.nl))
* 
* $Author: bablokb $
* $Revision: 1.1 $
*
* License: GPL2
* ----------------------------------------------------------------------------- */

#define EMPTY_PARTITION		0
#define EXTENDED_PARTITION	5
#define WIN98_EXTENDED		0x0f
#define DM6_AUX1PARTITION	0x51
#define DM6_AUX3PARTITION	0x53
#define DM6_PARTITION		0x54
#define EZD_PARTITION		0x55
#define LINUX_SWAP              0x82
#define LINUX_NATIVE	        0x83
#define LINUX_EXTENDED		0x85
#define BSD_PARTITION		0xa5
#define NETBSD_PARTITION	0xa9

struct geometry {
	unsigned long cylindersize;
	unsigned long heads, sectors, cylinders;
	unsigned long start;
};

typedef struct { unsigned char h,s,c; } chs; /* has some c bits in s */
typedef struct { unsigned long h,s,c; } longchs;

struct partition {
    unsigned char bootable;		/* 0 or 0x80 */
    chs begin_chs;
    unsigned char sys_type;
    chs end_chs;
    unsigned int start_sect;	/* starting sector counting from 0 */
    unsigned int nr_sects;		/* nr of sectors in partition */
};

struct part_desc {
    unsigned long start;
    unsigned long size;
    unsigned long sector, offset; /* disk location of this info */
    struct partition p;
    struct part_desc *ep;	  /* extended partition containing this one */
    int ptype;
#define DOS_TYPE	0
#define BSD_TYPE	1
};

struct disk_desc {
    struct part_desc partitions[512];
    int partno;
};

struct sector {
    struct sector *next;
    unsigned long sectornumber;
    int to_be_written;
    char data[512];
};
